#include <math.h>
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>

struct circle {
  double r;
}; 

struct square{
  double a;
};

struct triangle {
  double a;
  double b;
  double c;
};

enum fig_tag {fig_circle, fig_square, fig_triangle };

typedef struct figure {
   enum fig_tag t;
   union {
    struct circle c;
    struct square s;
    struct triangle t;
    } f;
   } figure;

double perimeter(figure *f) {
  switch (f-> t) {
    case fig_circle: 
      return (2*M_PI*f-> f.c.r); 
        /* M_PI is not C90?! */
    case fig_square: 
      return (4*f-> f.s.a);
    case fig_triangle: 
      return (f->f.t.a+ f-> f.t.b+ f-> f.t.c);
  }
  return 0; /* otherwise gcc issues a warning */
}

/* Eher idiomatisch: Konstruktur für Dreiecke */
figure *triangle(double a, double b, double c) 
{
  figure *t;

  assert(a <= b+ c && b <= a+ c && c <= a+ b);
  if ((t = (figure *)malloc(sizeof(*t)))== NULL) { fprintf(stderr, "Out of memory.\n"); exit(-1); }
  t-> t= fig_triangle; t-> f.t.a = a; t->f.t.b= b; t-> f.t.c= c;
  return t;
}

int main(int argc, char *argv[])
{
  figure c = { .t= fig_circle, .f = { .c = { 2.0 }}};
  figure s = { .t= fig_square, .f = { .s = { 3.0 }}};
  figure t = { .t= fig_triangle, .f = { .t= {1.0, 2.0, 3.0 }}};

  figure *t1;
  t1 = triangle(3, 4, 5);

  printf ("Perimeters (1): %f, %f, %f\n", perimeter(&c), perimeter(&s), perimeter(&t));
  printf ("Perimeters (2): %f\n", perimeter(t1));
  return 0;
}