abstract class Figure {
    abstract double perimeter();
}

class Circle extends Figure {
    private final double r;
    Circle(double r) { this.r= r; }

    double perimeter() { return Math.PI*2*r; }
}

class Square extends Figure {
    private final double a;
    Square(double a) { this.a= a; }

    double perimeter() { return 4*a; }
}

class Triangle extends Figure {
    private final double a, b, c;
    Triangle(double a, double b, double c)
      { // We can assert an invariant (the triangular inequalities)
        assert(a <= b+c && b <= a+c && c <= a+b);
        this.a= a; this.b= b; this.c= c; 
      }
      double perimeter() { return a+b+c; }
}

class figures {
  public static void main(String[] argc)
  {
    Figure c= new Circle(2);
    Figure s= new Square(3);
    Figure t= new Triangle(1,2,3);
    Figure figs[] = {c, s, t};

    for (Figure f: figs) {
      System.out.println("Perimeter= "+ f.perimeter());
    }

  }

}